"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  defaultRuleProperties: true,
  defaultItemProperties: true,
  defaultRule: true,
  defaultRoot: true
};
exports.defaultRuleProperties = exports.defaultRule = exports.defaultRoot = exports.defaultItemProperties = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _immutable = _interopRequireDefault(require("immutable"));
var _uuid = _interopRequireDefault(require("./uuid"));
var _getNewValueForFieldOp = require("./getNewValueForFieldOp");
var _stuff = require("./stuff");
var _defaultUtils = require("./defaultUtils");
Object.keys(_defaultUtils).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _defaultUtils[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _defaultUtils[key];
    }
  });
});
var _validation = require("./validation");
var _configUtils = require("./configUtils");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var defaultRuleProperties = exports.defaultRuleProperties = function defaultRuleProperties(config) {
  var parentRuleGroupField = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var item = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
  var canUseDefaultFieldAndOp = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
  var canGetFirst = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
  var field = null,
    operator = null,
    fieldSrc = null;
  var showErrorMessage = config.settings.showErrorMessage;
  if (item) {
    var _item$properties, _item$properties2, _item$properties3;
    fieldSrc = item === null || item === void 0 || (_item$properties = item.properties) === null || _item$properties === void 0 ? void 0 : _item$properties.fieldSrc;
    field = item === null || item === void 0 || (_item$properties2 = item.properties) === null || _item$properties2 === void 0 ? void 0 : _item$properties2.field;
    operator = item === null || item === void 0 || (_item$properties3 = item.properties) === null || _item$properties3 === void 0 ? void 0 : _item$properties3.operator;
  } else if (canUseDefaultFieldAndOp) {
    field = (0, _defaultUtils.getDefaultField)(config, canGetFirst, parentRuleGroupField);
    if (field) {
      fieldSrc = (0, _stuff.isImmutable)(field) ? "func" : "field";
    } else {
      fieldSrc = (0, _defaultUtils.getDefaultFieldSrc)(config);
    }
    operator = (0, _defaultUtils.getDefaultOperator)(config, field, true);
  } else {
    fieldSrc = (0, _defaultUtils.getDefaultFieldSrc)(config);
  }
  var current = new _immutable["default"].Map({
    fieldSrc: fieldSrc,
    field: field,
    operator: operator,
    value: new _immutable["default"].List(),
    valueSrc: new _immutable["default"].List(),
    //used for complex operators like proximity
    operatorOptions: (0, _defaultUtils.defaultOperatorOptions)(config, operator, field)
  });
  if (showErrorMessage) {
    current = current.set("valueError", new _immutable["default"].List());
  }
  if (field && operator) {
    var canFix = false;
    var _getNewValueForFieldO = (0, _getNewValueForFieldOp.getNewValueForFieldOp)({
        validateValue: _validation.validateValue,
        validateRange: _validation.validateRange
      }, config, config, current, field, operator, "operator", canFix),
      newValue = _getNewValueForFieldO.newValue,
      newValueSrc = _getNewValueForFieldO.newValueSrc,
      newValueType = _getNewValueForFieldO.newValueType,
      newValueError = _getNewValueForFieldO.newValueError,
      newFieldError = _getNewValueForFieldO.newFieldError;
    current = current.set("value", newValue).set("valueSrc", newValueSrc).set("valueType", newValueType);
    if (showErrorMessage) {
      current = current.set("valueError", newValueError).set("fieldError", newFieldError);
    }
  }
  var fieldConfig = (0, _configUtils.getFieldConfig)(config, field);
  if ((fieldConfig === null || fieldConfig === void 0 ? void 0 : fieldConfig.type) === "!group") {
    var conjunction = (0, _defaultUtils.defaultGroupConjunction)(config, fieldConfig);
    current = current.set("conjunction", conjunction);
  }
  return current;
};
var defaultItemProperties = exports.defaultItemProperties = function defaultItemProperties(config, item) {
  return (item === null || item === void 0 ? void 0 : item.type) == "group" ? (0, _defaultUtils.defaultGroupProperties)(config) : defaultRuleProperties(config, null, item);
};
var defaultRule = exports.defaultRule = function defaultRule(id, config) {
  return (0, _defineProperty2["default"])({}, id, new _immutable["default"].Map({
    type: "rule",
    id: id,
    properties: defaultRuleProperties(config)
  }));
};
var defaultRoot = exports.defaultRoot = function defaultRoot(config) {
  var canAddDefaultRule = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  return new _immutable["default"].Map({
    type: "group",
    id: (0, _uuid["default"])(),
    children1: new _immutable["default"].OrderedMap(canAddDefaultRule ? _objectSpread({}, defaultRule((0, _uuid["default"])(), config)) : {}),
    properties: (0, _defaultUtils.defaultGroupProperties)(config)
  });
};